package angarnet

import (
	"fmt"

	"wartank/pkg/components/sectionnet"
	"wartank/pkg/types"
)

/*
	Объект сетевого ангара
*/

// AngarNet -- объект сетевого ангара
type AngarNet struct {
	*sectionnet.SectionNet
	server types.IServer
	bot    types.IServBot
}

// NewAngarNet -- возвращает новый *AngarNet
func NewAngarNet(server types.IServer, bot types.IServBot) (*AngarNet, error) {
	{ // Предусловия
		if server == nil {
			return nil, fmt.Errorf("NewAngarNet(): IServer == nil")
		}
		if bot == nil {
			return nil, fmt.Errorf("NewAngarNet(): IServBot is nil")
		}
	}

	sf := &AngarNet{
		server: server,
		bot:    bot,
	}

	return sf, nil
}

func (sf *AngarNet) Run() error {
	sf.SectionNet = sectionnet.NewSectionNet(sf.server, sf.bot, sf.bot.Angar(), "http://wartank.ru/angar")
	return nil
}
